import { Module } from "../model/module.ts";
import { defineStore } from "pinia";

const moduleStore = defineStore("moduleStore", {
  state: () => ({
    modules: [] as Module[],
  }),
  actions: {
    addModule(module: Module) {
      this.modules.push(module);
    },
    removeModule(module: Module) {
      this.modules.splice(this.modules.indexOf(module), 1);
    },
    removeAllModules() {
      this.modules = [];
    },
  },
});

export default moduleStore;
